/*
  -------------------- file sort.h
  Created Feb. 1992 by Andrew Shapira, Rensselaer Polytechnic Institute.

	Copyright (C) 1992 Andrew Shapira.

	This file is part of the Ntuplib library.

	Ntuplib is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	Ntuplib is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with the Ntuplib Library; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _020992_124407_sort
#define _020992_124407_sort

#include "common.h"

#define ISORT_COUNT
#ifdef  ISORT_COUNT
extern int isort_moves;
#endif  /*ISORT_COUNT*/


/*  Sort an array of integers.  Use this like a function call.
*/

int     int_compare P ((const void *, const void *));
int     int_compare_descending P(( const void  *p1, const void  *p2 ));
void    intsort P(( int *, int, int, int ));
int     bfind P((const void *, void *, const size_t, const size_t,
                              int (*) (const void *, const void *) ));
int     binsert_withoutdups P((const void *, void *, size_t *, const size_t,
                              int (*) (const void *, const void *)));
int     binsert_withdups P((const void *, void *, const size_t, const size_t,
                              int (*) (const void *, const void *)));
void    ssort P((void *, const size_t, const size_t,
                              int (*)(const void *, const void *)));
void    isort P((void *, const size_t, const size_t,
                              int (*)(const void *, const void *)));

#endif /* _020992_124407_sort */
